# Walk 2 School

Walk 2 School is an innovative mobile app designed to encourage high school students to choose walking over driving. This app not only promotes physical activity, but also allows users to earn tangible rewards as they achieve various milestones. By turning walking into a social activity, the app connects students with their peers and fosters a sense of community. With the ability to log daily walks, track progress over time, and compete with friends on a leaderboard, Walk 2 School provides an engaging and interactive experience for its users. Overall, Walk 2 School is an effective tool for improving the health and well-being of high school students while also promoting sustainable transportation.

## App Suite

### &ensp; Walk2School
  * Home Page: The home page serves as the foundation of this app, serving as both the starting and ending point for walks. However, to ensure the integrity of the app's purpose, there are several conditions that must be met before a walk can be initiated. These include it being a weekday, at a time before school starts (to prevent tardiness), and no previous walks on that day. At the end of each walk, further conditions must be met to verify its validity, such as maintaining a speed limit of 25mph to ensure the user truly walked, a minimum distance of 50m traveled, and a distance of at least 100m from the school upon completion. To avoid ending a walk prematurely and invalidating points, the app prompts the user to confirm their intention to end the walk and meet all necessary conditions. Once a walk is successfully initiated, the user can view a percentage indicator showing their progress towards the school, as well as essential data points such as the distance traveled during their current trip, their all-time walking distance, current streak, and all-time points. 
  * Active Users Page: The Active Users page is a key feature that highlights the social aspect of walking. Through this page, users can view a list of other individuals who are also using the app, and easily identify those who are currently walking. By seeing which friends are walking at the same time, users can connect and coordinate to form walking groups, which adds to the overall sense of community and accountability. This feature is designed to encourage users to engage with others, foster new relationships, and make walking a fun and social activity. 
  * Rewards Page: The Rewards page is a powerful tool that directly incentivizes students to participate in the program. Any rewards that teachers or administrators add to this page can be purchased by students using the points they earn from walking. To motivate students who live further from the school, each meter walked is worth one point. Additionally, if a student walks for multiple days in a row, their streak increases and acts as a multiplier on their points (e.g., a two-day streak is worth 2x points). The streak resets every week. The Redeemed Rewards page displays all items that students have purchased and whether or not the teacher has fulfilled the request. This page also provides a full purchase history, allowing students to track their progress and celebrate their achievements. 
 * Leaderboard Page: The Leaderboard page is a simple yet powerful feature that allows students to see the point totals of their peers, ranked in order from the highest to the lowest. By showcasing the top performers, this page promotes healthy competition among students and encourages them to walk more frequently to increase their point totals. The leaderboard also fosters a sense of community by providing a platform for students to celebrate their achievements and compare their progress with others.


### &ensp; Admin Panel
The Admin Panel is a powerful tool designed for teachers and administrators to manage the rewards system and orders from students. With this panel, teachers and administrators can add or remove rewards, set point values for each reward, and approve student orders. This feature streamlines the process of managing the rewards program, allowing teachers to focus on the needs of their students. By giving educators control over the rewards system, the Admin Panel fosters a collaborative environment where teachers and students can work together to promote healthy habits and achieve wellness goals.
  * Shop Status Page: The listings page is a powerful tool that enables admin users to create and manage listings for the rewards program. When creating a new listing, admins must provide several important details, including the name, price, quantity, image URL, and description. With these fields, admins can create detailed and engaging listings that motivate students to participate in the program. Additionally, admins can choose to create a listing and make it invisible to users until a later date, providing flexibility and control over the rewards system. 
  * Orders Page: The Orders page is an essential feature that allows teachers to manage and fulfill orders made by students in the rewards program. On this page, teachers can view a queue of orders that have been redeemed, each with a variety of attributes such as the student username, item name, item price, item quantity, item description, date of purchase, and status (fulfilled or not). With this comprehensive view of student orders, teachers can stay on top of fulfilling requests and maintaining an accurate inventory. Moreover, the page includes a button on each order, allowing teachers to mark the item as fulfilled once it has been distributed to the student. 


## Technologies Used

- Flutter framework for mobile app development
- Express.js framework for backend development
- MongoDB database for storing user data
- Vercel for hosting the backend API

## Screenshots

![Screenshot 1](/readmeimgs/active.png)
![Screenshot 2](/readmeimgs/home.png)
![Screenshot 3](/readmeimgs/leaderboard.png)
![Screenshot 2](/readmeimgs/redeem.png)
![Screenshot 3](/readmeimgs/redeemed.png)
## Installation

1. Clone the repository to your local machine
2. Install dependencies using `npm install`
3. Run the server using `npm run start`
4. Run the app on an Android or iOS device using `flutter run`

## Usage

To use Walk2School app, follow these steps:

1. Create an account or log in using your existing credentials.
2. Log your daily walks using the app's built-in tracking feature.
3. Earn points by walking and use them to purchase rewards from the Rewards page.
4. Connect with friends and form walking groups on the Active Users page.
5. Check your progress and all-time walking data on the Home page.
6. Check the leaderboard on the Leaderboard page to see how you rank among your peers.

## API Documentation

The app's backend API provides endpoints for retrieving user data, logging walks, and updating user profiles.

For detailed documentation of the API endpoints, see the `API.md` file in the project repository.

## License

TBD

## Authors

- Dylan Nguyen
- Nathan Pollock

## Acknowledgments

We would like to thank the following individuals and organizations for their support and contributions to this project:
- Serena Mower, Benjamin Brodeur, and Andrei Ignatiev for writing the research paper concurrently with application development.
- Braude College of Engineering sponsors Anat Dahan and Nirit Gavish, along with student helper Bar Levy, for invaluable support.
- Project advisors Svetlana Nikitina and Ivan Mardilovich for guidance and feedback.
- The Flutter and Express.js development communities for valuable resources and documentation.
- Our families and friends for encouragement and support.
